#include "boxelworld.h"

extern float plx,ply,plz,plr,plj,pry;

void blend_anim(int mode);

#define SPEED 1.2
#define RSPEED 0.05
#define macro_mov(op,vec) \
	VECTOR m; \
	vec_rot(&m,vec,plr,1); \
	 \
	float vx,vy,vz; \
	 \
	vx = m.x*SPEED; \
	vy = m.y*SPEED; \
	vz = m.z*SPEED; \
	\
	float a,b,c; \
	\
	a=plx,b=ply,c=plz; \
	\
	plx op= vx; \
	ply op= vy; \
	plz op= vz; \
	\
	float h; \
	chk_gnd(&h);\
	\
	plx = a; \
	ply = b; \
	plz = c; \
	\
	if(h <= 0) { \
		plx op= vx; \
		ply op= vy; \
		plz op= vz; \
	} \


void player_move(void)
{
	char kst[256];

	GetHitKeyStateAll(kst);

	int pam = 0;
	static int hf = 0;

	float d;

	//if(kst[KEY_INPUT_A]) plr -= RSPEED;
	//if(kst[KEY_INPUT_D]) plr += RSPEED;
	if(kst[KEY_INPUT_A]) {
		macro_mov(+,VGet(1,0,0));

		pam = 1;
	}
	if(kst[KEY_INPUT_D]) {
		macro_mov(-,VGet(1,0,0));

		pam = 1;
	}
	if(kst[KEY_INPUT_W]) {
		macro_mov(-,VGet(0,0,1));

		pam = 1;
	}
	if(kst[KEY_INPUT_S]) {
		macro_mov(+,VGet(0,0,1));

		pam = 1;
	}
	if(kst[KEY_INPUT_SPACE] && hf) {
		plj = 3;
		hf = 0;
	}

	ply += plj;

	plj -= 0.2;

	if(chk_gnd(&d) && plj < 0) {
		plj = 0;
		ply = d;
		hf = 1;
	} else if(d != 0) {
		pam = 2;
	}

	blend_anim(pam);
}